## tlsh 0.1.0

=== DESCRIPTION ===
Package: tlsh
Type: Package
Title: Transitive Locality-Sensitive Hashing (LSH) for Record Linkage
Version: 0.1.0
Authors@R: person("Rebecca", "Steorts", email = "beka@stat.duke.edu",
  role = c("aut", "cre"))
Depends: R (>= 3.5.0), blink, stats, utils, plyr, igraph, bit64
Imports:
Suggests: knitr, ggplot2, rmarkdown
VignetteBuilder: knitr
Description: An implementation of the blocking algorithm transitive locality-sensitive hashing (TLSH) in Steorts, Ventura, Sadinle, Fienberg (2014) <DOI:10.1007/978-3-319-11257-2_20>, which is a k-means variant of locality sensitive hashing. The method is illustrated with examples and a vignette. 
Encoding: UTF-8
LazyData: true
License: GPL-3
RoxygenNote: 7.1.1.9000
NeedsCompilation: no
Packaged: 2020-11-02 16:22:06 UTC; rebeccasteorts
Author: Rebecca Steorts [aut, cre]
Maintainer: Rebecca Steorts <beka@stat.duke.edu>
Repository: CRAN
Date/Publication: 2020-11-06 17:00:02 UTC

## tlsh 3.2.1+20150727

=== CMakeLists.txt ===
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 2.6)

project(TLSH)

set(VERSION_MAJOR 3)
set(VERSION_MINOR 2)
set(VERSION_PATCH 1)

# TLSH uses only half the counting buckets.
# It can use all the buckets now.
set(TLSH_BUCKETS_128 1)
if(TLSH_BUCKETS_128 EQUAL 1)
  set(TLSH_HASH "compact hash")
else()
  set(TLSH_HASH "full hash")
  add_definitions(-DBUCKETS_256)
endif()

# TLSH uses 1 byte checksum. The collision rate is 1 in 24.
# It can use 3 bytes checksum now. That collision rate in 1 in 5800.
set(TLSH_CHECKSUM_1B 1)
if(TLSH_CHECKSUM_1B EQUAL 1)
  set(TLSH_CHECKSUM "1 byte checksum")
else()
  set(TLSH_CHECKSUM "3 bytes checksum")
  add_definitions(-DCHECKSUM_3B)
endif()

# write a file with the VERSION information
file(REMOVE VERSION)
file(WRITE VERSION 
  "TLSH version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${TLSH_HASH}, ${TLSH_CHECKSUM}\n")
  
file(REMOVE include/version.h)
file(WRITE include/version.h
  "/****************************************************\n"
  " * This file is generated by cmake.  Modify the top\n"
  " * level CMakeLists.txt to change the VERSION numbers\n"
  " ****************************************************/\n\n"
  "#define VERSION_MAJOR ${VERSION_MAJOR}\n"
  "#define VERSION_MINOR ${VERSION_MINOR}\n"
  "#define VERSION_PATCH ${VERSION_PATCH}\n"
  "#define TLSH_HASH \"${TLSH_HASH}\"\n"
  "#define TLSH_CHECKSUM \"${TLSH_CHECKSUM}\"\n")

if (CMAKE_BUILD_TYPE STREQUAL Debug)
    set(CMAKE_CXX_FLAGS "-g")
else(CMAKE_BUILD_TYPE STREQUAL Debug)
    if(CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_CXX_FLAGS "-O2")        ## Optimize
    endif()
    if(MSVC)
        set(CMAKE_CXX_FLAGS "/O2")        ## Optimize
    endif()
endif(CMAKE_BUILD_TYPE STREQUAL Debug)

enable_testing()

include_directories(include)
add_subdirectory(src)
add_subdirectory(test)
add_subdirectory(utils)
add_subdirectory(Testing)

set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "TLSH-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"^${PROJECT_SOURCE_DIR}/bin/"
"^${PROJECT_SOURCE_DIR}/lib/"
"^${PROJECT_SOURCE_DIR}/build/"
"^${PROJECT_SOURCE_DIR}/py_ext/data/"
"^${PROJECT_SOURCE_DIR}/py_ext/build/"
"^${PROJECT_SOURCE_DIR}/Testing/tmp/"
"^${PROJECT_SOURCE_DIR}/CMakeFiles/"
)
include(CPack)

=== debian/changelog ===
tlsh (3.2.1+20150727-1) unstable; urgency=low

  * Initial release. (Closes: #794219)

 -- Jérémy Bobbio <lunar@debian.org>  Fri, 31 Jul 2015 16:37:27 +0200

=== debian/control ===
Source: tlsh
Maintainer: Jérémy Bobbio <lunar@debian.org>
Section: admin
Priority: extra
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               python-all-dev,
               python-docutils,
               python-setuptools
Standards-Version: 3.9.6
Homepage: https://github.com/trendmicro/tlsh
Vcs-Git: git://anonscm.debian.org/collab-maint/tlsh.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/tlsh.git
X-Python-Version: >= 2.7

Package: tlsh-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: compare similar files using fuzzy hashing
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the tlsh_unittest utility, a command-line tool to
 generate TLSH hash values and compare TLSH hash values to determine
 similar files.

# The following package is on hold until time is spent fixing the
# code to hide the implementation again from library users.
# See upstream commit 1a8f1c581 which feels confused.
#
#Package: libtlsh-dev
#Section: libdevel
#Architecture: any
#Depends: ${misc:Depends}
#Description: fuzzy hashing library - development files
# The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
# used to compare similar but not identical files.
# .
# Identifying near duplicates and similar files is known to be useful to
# identify malware samples with similar binary file structure, variants of spam
# email, or backups with corrupted files.
# .
# This package contains the static library.

Package: python-tlsh
Section: python
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: fuzzy hashing library - Python module
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the Python module.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = tlsh

%:
	dh $@ --with=python2 --buildsystem=cmake

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --sourcedirectory=py_ext --buildsystem=pybuild

override_dh_auto_install: debian/tlsh_unittest.1
	dh_auto_install
	dh_auto_install --sourcedirectory=py_ext --buildsystem=pybuild

override_dh_python2:
	dh_python2 -O--sourcedirectory=py_ext -O--buildsystem=pybuild

debian/tlsh_unittest.1: debian/tlsh_unittest.1.rst
	rst2man $< $@

override_dh_clean:
	rm -f debian/tlsh_unittest.1
	dh_clean

## tlsh 3.4.1+20151014

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 project(TLSH)
 
 set(VERSION_MAJOR 3)
-set(VERSION_MINOR 2)
+set(VERSION_MINOR 4)
 set(VERSION_PATCH 1)
 
 # TLSH uses only half the counting buckets.
@@ -43,6 +43,8 @@
 # write a file with the VERSION information
 file(REMOVE VERSION)
 file(WRITE VERSION 
+  "// This file is generated by cmake.  Modify\n"
+  "// CMakeLists.txt to change the VERSION numbers\n"
   "TLSH version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${TLSH_HASH}, ${TLSH_CHECKSUM}\n")
   
 file(REMOVE include/version.h)

=== test/CMakeLists.txt ===
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_executable(tlsh_version tlsh_version.cpp)
target_link_libraries(tlsh_version tlsh)
set_target_properties(tlsh_version PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/test)
set_target_properties(tlsh_version PROPERTIES OUTPUT_NAME tlsh_version${BUILD_POSTFIX})

add_executable(simple_unittest simple_unittest.cpp)
target_link_libraries(simple_unittest tlsh)
set_target_properties(simple_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/test)
set_target_properties(simple_unittest PROPERTIES OUTPUT_NAME simple_unittest${BUILD_POSTFIX})

add_executable(tlsh_unittest tlsh_unittest.cpp)
target_link_libraries(tlsh_unittest tlsh)
set_target_properties(tlsh_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(tlsh_unittest PROPERTIES OUTPUT_NAME tlsh_unittest${BUILD_POSTFIX})

=== debian/changelog ===
tlsh (3.4.1+20151014-1) unstable; urgency=medium

  * New upstream release.
  * Use new incremental interface in Python autopkgtest.

 -- Jérémy Bobbio <lunar@debian.org>  Thu, 15 Oct 2015 16:27:11 +0200

tlsh (3.2.1+20150727-2) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * Remove artifacts from the previous build in the clean rule.
  * Build a python3 package.

  [ Jérémy Bobbio ]
  * Add autopkgtests.

 -- Jérémy Bobbio <lunar@debian.org>  Wed, 16 Sep 2015 17:44:06 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
                debhelper (>= 9),
                dh-python,
                python-all-dev,
+               python3-all-dev,
                python-docutils,
                python-setuptools
 Standards-Version: 3.9.6
@@ -60,3 +61,17 @@
  email, or backups with corrupted files.
  .
  This package contains the Python module.
+
+Package: python3-tlsh
+Section: python
+Architecture: any
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Description: fuzzy hashing library - Python3 module
+ The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
+ used to compare similar but not identical files.
+ .
+ Identifying near duplicates and similar files is known to be useful to
+ identify malware samples with similar binary file structure, variants of spam
+ email, or backups with corrupted files.
+ .
+ This package contains the Python3 module.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export PYBUILD_NAME = tlsh
 
 %:
-	dh $@ --with=python2 --buildsystem=cmake
+	dh $@ --with=python2,python3 --buildsystem=cmake
 
 override_dh_auto_build:
 	dh_auto_build
@@ -16,9 +16,18 @@
 override_dh_python2:
 	dh_python2 -O--sourcedirectory=py_ext -O--buildsystem=pybuild
 
+override_dh_python3:
+	dh_python3 -O--sourcedirectory=py_ext -O--buildsystem=pybuild
+
 debian/tlsh_unittest.1: debian/tlsh_unittest.1.rst
 	rst2man $< $@
 
 override_dh_clean:
 	rm -f debian/tlsh_unittest.1
+	rm -rf .pybuild
+	rm -rf py_ext/build
+	rm -rf bin
+	rm -rf lib
+	rm -f test/simple_unittest
+	rm -f test/tlsh_version
 	dh_clean

## tlsh 3.4.4+20151206

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 set(VERSION_MAJOR 3)
 set(VERSION_MINOR 4)
-set(VERSION_PATCH 1)
+set(VERSION_PATCH 4)
 
 # TLSH uses only half the counting buckets.
 # It can use all the buckets now.

=== src/CMakeLists.txt ===
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_library(tlsh STATIC tlsh.cpp tlsh_impl.cpp tlsh_util.cpp)
set_target_properties(tlsh PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/lib)
set_target_properties(tlsh PROPERTIES OUTPUT_NAME tlsh${BUILD_POSTFIX})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -14,12 +14,12 @@
 
 add_executable(tlsh_version tlsh_version.cpp)
 target_link_libraries(tlsh_version tlsh)
-set_target_properties(tlsh_version PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/test)
+set_target_properties(tlsh_version PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
 set_target_properties(tlsh_version PROPERTIES OUTPUT_NAME tlsh_version${BUILD_POSTFIX})
 
 add_executable(simple_unittest simple_unittest.cpp)
 target_link_libraries(simple_unittest tlsh)
-set_target_properties(simple_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/test)
+set_target_properties(simple_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
 set_target_properties(simple_unittest PROPERTIES OUTPUT_NAME simple_unittest${BUILD_POSTFIX})
 
 add_executable(tlsh_unittest tlsh_unittest.cpp)

=== utils/CMakeLists.txt ===
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_executable(rand_tags rand_tags.cpp)
target_link_libraries(rand_tags tlsh)
set_target_properties(rand_tags PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(rand_tags PROPERTIES OUTPUT_NAME rand_tags${BUILD_POSTFIX})

=== debian/changelog ===
tlsh (3.4.4+20151206-1.4build8) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 14:24:34 +0000

tlsh (3.4.4+20151206-1.4build7) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 05 Mar 2025 01:15:40 +0000

tlsh (3.4.4+20151206-1.4build6) plucky; urgency=medium

  * SRU: #2083480: No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 09:57:49 +0100

tlsh (3.4.4+20151206-1.4build5) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 11 Apr 2024 10:55:29 +0000

tlsh (3.4.4+20151206-1.4build4) noble; urgency=medium

  * No-change rebuild with Python 3.12 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 31 Oct 2023 18:02:19 +0000

tlsh (3.4.4+20151206-1.4build3) lunar; urgency=medium

  * Rebuild to drop Python 3.10 extension

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 28 Feb 2023 19:45:32 -0500

tlsh (3.4.4+20151206-1.4build2) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as supported

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 02 Nov 2022 11:22:20 +0000

tlsh (3.4.4+20151206-1.4build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 20:15:19 +0000

tlsh (3.4.4+20151206-1.4) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Use secure copyright file specification URI.
  * Bump debhelper from deprecated 9 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

  [ Mattia Rizzolo ]
  * Bump Standards-Version to 4.6.0, no changes needed.
  * Apply hints from the Multi-Arch hinter: set Multi-Arch:same to libtlsh0,
    libtlsh-dev, python3-tlsh.
  * Add patch from upstream to avoid a comparison between a pointer value and
    an integer.  Fixes build with GCC 11.  Closes: #984365
  * Add /usr/bin/tlsh as a link to tlsh_unittest.  Closes: #952449
    Thanks to Stefano Zacchiroli <zack@debian.org> for the patch.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 12 Oct 2021 11:29:09 +0200

tlsh (3.4.4+20151206-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * d/control:
    + Move the git repository to salsa.debian.org.
    + Drop now unused X-Python-Version field.
  * Run wrap-and-sort.
  * Reinstate the actual python autopkgtests, accidentally removed in
    the previous upload.  Closes: #944072

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 13 Nov 2019 16:07:32 +0100

tlsh (3.4.4+20151206-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python2 support; Closes: #938671

 -- Sandro Tosi <morph@debian.org>  Thu, 17 Oct 2019 17:41:52 -0400

tlsh (3.4.4+20151206-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Niels Thykier ]
  * Set Rules-Requires-Root to "no" as tlsh does not need (fake)root.
  * Bump priority to optional as extra has been deprecated.

  [ Helmut Grohne ]
  * Multiarchify python Build-Depends. (Closes: #892930)

 -- Niels Thykier <niels@thykier.net>  Sun, 06 Jan 2019 14:56:51 +0000

tlsh (3.4.4+20151206-1) unstable; urgency=low

  * New upstream release.
  * Be explicit in which buildsystem we want to use in debian/rules.
  * Remove generated version files in clean rules.
  * Put misc:Depends after shlibs:Depends in debian/control.
  * Ship tlsh shared library now that upstream has made the required
    changes. This adds three new patches and one autopkgtest which tries
    to build and run a test program.
  * Add a patch to call Tlsh constructor when creating Tlsh objects in
    Python.

 -- Jérémy Bobbio <lunar@debian.org>  Sat, 16 Jan 2016 16:19:58 +0100

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = tlsh

%:
	dh $@ --with=python3 --buildsystem=cmake

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	dh_auto_build --sourcedirectory=py_ext --buildsystem=pybuild

override_dh_auto_install: debian/tlsh_unittest.1
	dh_auto_install --buildsystem=cmake
	dh_auto_install --sourcedirectory=py_ext --buildsystem=pybuild

override_dh_python3:
	dh_python3 -O--sourcedirectory=py_ext -O--buildsystem=pybuild

debian/tlsh_unittest.1: debian/tlsh_unittest.1.rst
	rst2man $< $@

override_dh_clean:
	rm -f debian/tlsh_unittest.1
	rm -rf .pybuild
	rm -rf py_ext/build
	rm -rf bin
	rm -rf lib
	rm -rf VERSION include/version.h
	rm -f test/simple_unittest
	rm -f test/tlsh_version
	dh_clean

=== debian/tests/control ===
Tests: use-tlsh-unittest
Depends:
 tlsh-tools,

Tests: use-python3-tlsh
Depends:
 python3-tlsh,

Tests: build-test-program
Depends:
 build-essential,
 libtlsh-dev,

## tlsh 4.8.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,11 @@
+# TLSH is provided for use under two licenses: Apache OR BSD.
+# Users may opt to use either license depending on the license
+# restictions of the systems with which they plan to integrate
+# the TLSH code.
+#
+# ==============
+# Apache License
+# ==============
 # Copyright 2013 Trend Micro Incorporated
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
@@ -11,21 +19,58 @@
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
+#
+# ===========
+# BSD License
+# ===========
+# Copyright (c) 2013, Trend Micro Incorporated
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification,
+# are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice, this
+#    list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+
+# 3. Neither the name of the copyright holder nor the names of its contributors
+#    may be used to endorse or promote products derived from this software without
+#    specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
+# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
+# OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 2.6)
 
 project(TLSH)
 
-set(VERSION_MAJOR 3)
-set(VERSION_MINOR 4)
-set(VERSION_PATCH 4)
+set(VERSION_MAJOR 4)
+set(VERSION_MINOR 8)
+set(VERSION_PATCH 2)
 
 # TLSH uses only half the counting buckets.
 # It can use all the buckets now.
 set(TLSH_BUCKETS_128 1)
+if(TLSH_BUCKETS_48 EQUAL 1)
+  set(TLSH_HASH "min hash")
+  add_definitions(-DBUCKETS_48)
+endif()
 if(TLSH_BUCKETS_128 EQUAL 1)
   set(TLSH_HASH "compact hash")
-else()
+  add_definitions(-DBUCKETS_128)
+endif()
+if(TLSH_BUCKETS_256 EQUAL 1)
   set(TLSH_HASH "full hash")
   add_definitions(-DBUCKETS_256)
 endif()
@@ -33,12 +78,23 @@
 # TLSH uses 1 byte checksum. The collision rate is 1 in 24.
 # It can use 3 bytes checksum now. That collision rate in 1 in 5800.
 set(TLSH_CHECKSUM_1B 1)
+
+if(TLSH_CHECKSUM_0B EQUAL 1)
+  set(TLSH_CHECKSUM "no checksum")
+  add_definitions(-DCHECKSUM_0B)
+endif()
 if(TLSH_CHECKSUM_1B EQUAL 1)
   set(TLSH_CHECKSUM "1 byte checksum")
-else()
+endif()
+if(TLSH_CHECKSUM_3B EQUAL 1)
   set(TLSH_CHECKSUM "3 bytes checksum")
   add_definitions(-DCHECKSUM_3B)
 endif()
+
+# setting TLSH_DISTANCE_PARAMETERS to 1 allows you to set command line arguments
+# to set - and hence experiment with the distance parameters
+#	by default this is zero
+set(TLSH_DISTANCE_PARAMETERS 0)
 
 # write a file with the VERSION information
 file(REMOVE VERSION)
@@ -48,7 +104,8 @@
   "TLSH version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH} ${TLSH_HASH}, ${TLSH_CHECKSUM}\n")
   
 file(REMOVE include/version.h)
-file(WRITE include/version.h
+file(REMOVE include/tlsh_version.h)
+file(WRITE include/tlsh_version.h
   "/****************************************************\n"
   " * This file is generated by cmake.  Modify the top\n"
   " * level CMakeLists.txt to change the VERSION numbers\n"
@@ -58,17 +115,34 @@
   "#define VERSION_PATCH ${VERSION_PATCH}\n"
   "#define TLSH_HASH \"${TLSH_HASH}\"\n"
   "#define TLSH_CHECKSUM \"${TLSH_CHECKSUM}\"\n")
+if(TLSH_DISTANCE_PARAMETERS EQUAL 1)
+file(APPEND include/tlsh_version.h
+  "#define TLSH_DISTANCE_PARAMETERS ${TLSH_DISTANCE_PARAMETERS}\n")
+endif()
 
 if (CMAKE_BUILD_TYPE STREQUAL Debug)
-    set(CMAKE_CXX_FLAGS "-g")
+    if(CMAKE_COMPILER_IS_GNUCXX)
+        set(CMAKE_CXX_FLAGS "-g")
+    endif()
 else(CMAKE_BUILD_TYPE STREQUAL Debug)
     if(CMAKE_COMPILER_IS_GNUCXX)
-        set(CMAKE_CXX_FLAGS "-O2")        ## Optimize
+        set(CMAKE_CXX_FLAGS "-O2 -fvisibility=internal")  ## Remove TlshImpl symbols
     endif()
     if(MSVC)
         set(CMAKE_CXX_FLAGS "/O2")        ## Optimize
     endif()
 endif(CMAKE_BUILD_TYPE STREQUAL Debug)
+
+if(MSVC)
+    add_definitions(-DWINDOWS -DTLSH_LIB)
+    include_directories(Windows)
+endif()
+
+# user can override CXX; make sure tests link and load properly regardless of LD_LIBRARY_PATH
+if(CMAKE_COMPILER_IS_GNUCXX)
+    set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc")
+    set(CMAKE_EXE_LINKER_FLAGS "-static-libstdc++")
+endif()
 
 enable_testing()
 
@@ -77,6 +151,10 @@
 add_subdirectory(test)
 add_subdirectory(utils)
 add_subdirectory(Testing)
+
+if(MSVC)
+    add_subdirectory(Windows)
+endif()
 
 set(CPACK_GENERATOR "TGZ")
 set(CPACK_SOURCE_GENERATOR "TGZ")

=== mingw/Makefile ===

INCLUDES= -I../include

CFLAGS=$(INCLUDES) -DMINGW

TARGETS=tlsh.exe simple_unittest.exe
OBJECTS=input_desc.o shared_file_functions.o tlsh.o tlsh_impl.o tlsh_util.o

all: $(TARGETS)

clean:
	del *.o $(TARGETS)

tlsh.exe: $(OBJECTS) tlsh_unittest.o
	g++ -o tlsh.exe $(OBJECTS) tlsh_unittest.o -static-libgcc -static-libstdc++

simple_unittest.exe: $(OBJECTS) simple_unittest.o
	g++ -o simple_unittest.exe $(OBJECTS) simple_unittest.o -static-libgcc -static-libstdc++

.cpp.o:
	g++ -c $(CFLAGS) $*.cpp

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,11 @@
+# TLSH is provided for use under two licenses: Apache OR BSD.
+# Users may opt to use either license depending on the license
+# restictions of the systems with which they plan to integrate
+# the TLSH code.
+#
+# ==============
+# Apache License
+# ==============
 # Copyright 2013 Trend Micro Incorporated
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
@@ -11,9 +19,41 @@
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License.
+#
+# ===========
+# BSD License
+# ===========
+# Copyright (c) 2013, Trend Micro Incorporated
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without modification,
+# are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice, this
+#    list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright notice,
+#    this list of conditions and the following disclaimer in the documentation
+#    and/or other materials provided with the distribution.
+
+# 3. Neither the name of the copyright holder nor the names of its contributors
+#    may be used to endorse or promote products derived from this software without
+#    specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
+# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
+# OF THE POSSIBILITY OF SUCH DAMAGE.
+
 
 add_executable(rand_tags rand_tags.cpp)
-target_link_libraries(rand_tags tlsh)
+target_link_libraries(rand_tags tlsh_static)
 set_target_properties(rand_tags PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
 set_target_properties(rand_tags PROPERTIES OUTPUT_NAME rand_tags${BUILD_POSTFIX})

=== tlsh_bh_tool/setup/Debian/requirements.txt ===
simplejson
pefile
m2crypto
pyOpenSSL
requests

=== tlsh_bh_tool/setup/MacOSX/requirements.txt ===
simplejson
requests
pefile
m2crypto
pyOpenSSL

=== debian/changelog ===
tlsh (4.8.2+ds-0.1) experimental; urgency=medium

  * Non-maintainer upload.

  * New upstream version 4.8.2+ds.
    + Fixes the python3 testing files location.  Closes: #939729
  * d/gbp.conf: drop the import-orig settigns: those directories are
    already removed by mk-origtargz
  * Add d/watch.
  * d/patches:
    + Refresh patches.
    + Delete patches applied upstream.
    + Add patch to make tlsh_unittest successfully link dynamically
    + Add patch to link libstdc++ dynamically.
    + Forward the patch to install the libraries in a multiarch location.
  * Update copyright.
    + From this release, the code is double-licensed Apache-2.0 OR BSD-3-clause.
  * d/rules: Use execute_after_* to simplify the commands.
  * Declaratively specify the python3 sequence by Build-Depending on it.
  * Ship the NOTICE.txt file, required by the Apache-2.0 license.
  * Rename library package for the new SONAME.
  * Update symbols file.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 12 Oct 2021 13:41:31 +0200

=== debian/control ===
Source: tlsh
Maintainer: Jérémy Bobbio <lunar@debian.org>
Section: admin
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 libpython3-all-dev,
 python3-all-dev:any,
 python3-docutils,
 python3-setuptools,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/trendmicro/tlsh
Vcs-Git: https://salsa.debian.org/debian/tlsh.git
Vcs-Browser: https://salsa.debian.org/debian/tlsh

Package: tlsh-tools
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: compare similar files using fuzzy hashing
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the tlsh_unittest utility, a command-line tool to
 generate TLSH hash values and compare TLSH hash values to determine
 similar files.

Package: libtlsh4
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: fuzzy hashing library
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the shared library itself.

Package: libtlsh-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libtlsh4 (= ${binary:Version}),
 ${misc:Depends},
Description: fuzzy hashing library - development files
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the development headers and the static library.

Package: python3-tlsh
Section: python
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: fuzzy hashing library - Python3 module
 The Trend Micro Locality Sensitive Hash is a fuzzy hash algorithm that can be
 used to compare similar but not identical files.
 .
 Identifying near duplicates and similar files is known to be useful to
 identify malware samples with similar binary file structure, variants of spam
 email, or backups with corrupted files.
 .
 This package contains the Python3 module.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = tlsh

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DTLSH_SHARED_LIBRARY=1

execute_after_dh_auto_build:
	dh_auto_build --sourcedirectory=py_ext --buildsystem=pybuild

execute_after_dh_auto_install: debian/tlsh_unittest.1
	dh_auto_install --sourcedirectory=py_ext --buildsystem=pybuild

override_dh_python3:
	dh_python3 -O--sourcedirectory=py_ext -O--buildsystem=pybuild

debian/tlsh_unittest.1: debian/tlsh_unittest.1.rst
	rst2man $< $@

override_dh_clean:
	rm -f debian/tlsh_unittest.1
	rm -rf .pybuild
	rm -rf py_ext/build
	rm -rf bin
	rm -rf lib
	rm -rf VERSION include/version.h include/tlsh_version.h
	rm -f test/simple_unittest
	rm -f test/tlsh_version
	dh_clean

=== debian/watch ===
version=4

opts=dversionmangle=auto,repacksuffix=+ds \
https://github.com/trendmicro/tlsh/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## tlsh 4.11.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 project(TLSH)
 
 set(VERSION_MAJOR 4)
-set(VERSION_MINOR 8)
+set(VERSION_MINOR 11)
 set(VERSION_PATCH 2)
 
 # TLSH uses only half the counting buckets.
@@ -125,11 +125,10 @@
         set(CMAKE_CXX_FLAGS "-g")
     endif()
 else(CMAKE_BUILD_TYPE STREQUAL Debug)
-    if(CMAKE_COMPILER_IS_GNUCXX)
-        set(CMAKE_CXX_FLAGS "-O2 -fvisibility=internal")  ## Remove TlshImpl symbols
-    endif()
     if(MSVC)
         set(CMAKE_CXX_FLAGS "/O2")        ## Optimize
+    else(MSVS)
+        set(CMAKE_CXX_FLAGS "-O3")
     endif()
 endif(CMAKE_BUILD_TYPE STREQUAL Debug)
 
@@ -140,9 +139,16 @@
 
 # user can override CXX; make sure tests link and load properly regardless of LD_LIBRARY_PATH
 if(CMAKE_COMPILER_IS_GNUCXX)
+    # issue #116 Library will not compile on CENTOS 7
+    # set(CMAKE_EXE_LINKER_FLAGS "-static-libstdc++")
     set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc")
-    set(CMAKE_EXE_LINKER_FLAGS "-static-libstdc++")
 endif()
+
+# from https://stackoverflow.com/questions/5395309/how-do-i-force-cmake-to-include-pthread-option-during-compilation
+set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
+# This flag seems to only be for older versions of CMake, such as https://cmake.org/cmake/help/v3.2/module/FindThreads.html
+set(THREADS_PREFER_PTHREAD_FLAG TRUE)
+find_package(Threads REQUIRED)
 
 enable_testing()

=== debian/changelog ===
tlsh (4.11.2+ds-2) unstable; urgency=low

  * d/gbp.conf: Update gbp configuration.
  * d/salsa-ci.yml: Add Salsa Ci configuration.
  * d/libtlsh4.symbols: Honor symbols varying regarding architecture bit count.

 -- Sven Geuer <sge@debian.org>  Fri, 28 Nov 2025 16:19:09 +0100

tlsh (4.11.2+ds-1) unstable; urgency=low

  * Upload to unstable.
  * Adopt package setting Maintainer to myself (Closes: #1087262).
  * d/libtlsh4.symbols: Update symbols file.
  * d/p/*:
    - Add distutils-to-setuptools.patch to fix lintian's
      uses-deprecated-python-stdlib.
    - Add honor-CPP+CXXFLAGS.patch making sure Debian's presets get applied.
  * d/watch: Convert watch file to version 5 format.
  * d/rules:
    - Activate hardenings.
    - Drop override_dh_clean, move removals to d/clean.
  * d/u/metadata: Add Repository, Repository-Browse and Changelog fields.
  * d/control:
    - Remove redundant 'Rules-Requires-Root: no'.
    - Bump Standards-Version to 4.7.2.
  * d/copyright:
    - Bump upstream's copyright years.
    - Update the list of packaging copyright holders.

 -- Sven Geuer <sge@debian.org>  Thu, 27 Nov 2025 17:37:47 +0100

tlsh (4.11.2+ds-0.1) experimental; urgency=medium

  * Non-maintainer upload.

  [ Mattia Rizzolo ]
  * New upstream version 4.11.2+ds.
  * Refresh patches link-to-stdcpp.patch and install-libraries.diff.

  [ Sven Geuer ]
  * Merge cmake4.patch from branch master into experimental.
  * d/p/*: Update patches cmake4.patch and create-shared-library.diff.
  * d/t/build-test-program: Adapt test to new upstream version.
  * d/rules: Remove py_ext/tlsh.egg-info when cleaning (Closes: #1045507).

 -- Sven Geuer <sge@debian.org>  Mon, 24 Nov 2025 17:43:22 +0100

tlsh (3.4.4+20151206-2) unstable; urgency=medium

  * QA upload.
  * d/p/*: Add cmake4.patch fixing FTBFS with CMake 4 (Closes: #1113579).

 -- Sven Geuer <sge@debian.org>  Sun, 23 Nov 2025 23:08:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: tlsh
-Maintainer: Jérémy Bobbio <lunar@debian.org>
+Maintainer: Sven Geuer <sge@debian.org>
 Section: admin
 Priority: optional
 Build-Depends:
@@ -10,8 +10,7 @@
  python3-all-dev:any,
  python3-docutils,
  python3-setuptools,
-Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/trendmicro/tlsh
 Vcs-Git: https://salsa.debian.org/debian/tlsh.git
 Vcs-Browser: https://salsa.debian.org/debian/tlsh

## tlsh 4.12.0%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,8 +56,8 @@
 project(TLSH)
 
 set(VERSION_MAJOR 4)
-set(VERSION_MINOR 11)
-set(VERSION_PATCH 2)
+set(VERSION_MINOR 12)
+set(VERSION_PATCH 0)
 
 # TLSH uses only half the counting buckets.
 # It can use all the buckets now.

## tlsh 4.12.0+ds

=== test/CMakeLists.txt ===
# TLSH is provided for use under two licenses: Apache OR BSD.
# Users may opt to use either license depending on the license
# restictions of the systems with which they plan to integrate
# the TLSH code.
#
# ==============
# Apache License
# ==============
# Copyright 2013 Trend Micro Incorporated
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# ===========
# BSD License
# ===========
# Copyright (c) 2013, Trend Micro Incorporated
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# 3. Neither the name of the copyright holder nor the names of its contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.

add_executable(simple_unittest simple_unittest.cpp)
target_link_libraries(simple_unittest PRIVATE tlsh_static)
target_link_libraries(simple_unittest PRIVATE)
set_target_properties(simple_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(simple_unittest PROPERTIES OUTPUT_NAME simple_unittest${BUILD_POSTFIX})

add_executable(tlsh_unittest tlsh_unittest.cpp)
target_link_libraries(tlsh_unittest PRIVATE tlsh_static)
target_link_libraries(tlsh_unittest PRIVATE)
set_target_properties(tlsh_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(tlsh_unittest PROPERTIES OUTPUT_NAME tlsh_unittest${BUILD_POSTFIX})
set_target_properties(tlsh_unittest PROPERTIES SKIP_BUILD_RPATH TRUE)

add_executable(timing_unittest timing_unittest.cpp)
target_link_libraries(timing_unittest PRIVATE tlsh_static)
target_link_libraries(timing_unittest PRIVATE)
set_target_properties(timing_unittest PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(timing_unittest PROPERTIES OUTPUT_NAME timing_unittest${BUILD_POSTFIX})
set_target_properties(timing_unittest PROPERTIES SKIP_BUILD_RPATH TRUE)

add_executable(order_bug order_bug.cpp)
target_link_libraries(order_bug PRIVATE tlsh_static)
target_link_libraries(order_bug PRIVATE)
set_target_properties(order_bug PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(order_bug PROPERTIES OUTPUT_NAME order_bug${BUILD_POSTFIX})
set_target_properties(order_bug PROPERTIES SKIP_BUILD_RPATH TRUE)

add_executable(tlsh_pattern tlsh_pattern.cpp)
target_link_libraries(tlsh_pattern PRIVATE tlsh_static)
target_link_libraries(tlsh_pattern PRIVATE)
set_target_properties(tlsh_pattern PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(tlsh_pattern PROPERTIES OUTPUT_NAME tlsh_pattern${BUILD_POSTFIX})
set_target_properties(tlsh_pattern PROPERTIES SKIP_BUILD_RPATH TRUE)

add_executable(tlsh_parts tlsh_parts.cpp)
target_link_libraries(tlsh_parts PRIVATE tlsh_static)
target_link_libraries(tlsh_parts PRIVATE)
set_target_properties(tlsh_parts PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set_target_properties(tlsh_parts PROPERTIES OUTPUT_NAME tlsh_parts${BUILD_POSTFIX})
set_target_properties(tlsh_parts PROPERTIES SKIP_BUILD_RPATH TRUE)

file(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
# issue #115 - CREATE_LINK does not work on CENTOS 7
# file(CREATE_LINK tlsh_unittest ${CMAKE_SOURCE_DIR}/bin/tlsh SYMBOLIC)

install(TARGETS tlsh_unittest DESTINATION bin)
install(CODE "file(CREATE_LINK tlsh_unittest \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/bin/tlsh SYMBOLIC)")

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,8 @@
 
 
 add_executable(rand_tags rand_tags.cpp)
-target_link_libraries(rand_tags tlsh_static)
+target_link_libraries(rand_tags PRIVATE tlsh_static)
+target_link_libraries(rand_tags PRIVATE)
 set_target_properties(rand_tags PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
 set_target_properties(rand_tags PROPERTIES OUTPUT_NAME rand_tags${BUILD_POSTFIX})

=== debian/changelog ===
tlsh (4.12.0+ds-2) unstable; urgency=medium

  * d/control: Update the Vcs-* fields to the team namespace.

 -- Sven Geuer <sge@debian.org>  Sun, 21 Dec 2025 15:21:56 +0100

tlsh (4.12.0+ds-1) unstable; urgency=medium

  * d/copyright: Exclude from source pre-built java and python objects.
  * New upstream version 4.12.0+ds
  * d/p/*:
    - Adapt patches to new upstream version.
    - Add cpu-agnostic-endianness.patch.
    - Add ensure-BUCKETS+CHECKSUM-config.patch.
  * d/t/build-test-program: Compare output against pre-known results.
  * d/control: Switch Maintainer to the Debian Security Tools Team and set
    Uploaders to myself.

 -- Sven Geuer <sge@debian.org>  Sat, 06 Dec 2025 21:19:33 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: tlsh
-Maintainer: Sven Geuer <sge@debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Uploaders: Sven Geuer <sge@debian.org>
 Section: admin
 Priority: optional
 Build-Depends:
@@ -12,8 +13,8 @@
  python3-setuptools,
 Standards-Version: 4.7.2
 Homepage: https://github.com/trendmicro/tlsh
-Vcs-Git: https://salsa.debian.org/debian/tlsh.git
-Vcs-Browser: https://salsa.debian.org/debian/tlsh
+Vcs-Git: https://salsa.debian.org/pkg-security-team/tlsh.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/tlsh
 
 Package: tlsh-tools
 Architecture: any
